package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/db/model"
	zhios_condition_statistics_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/utils"
	zhios_condition_statistics_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/utils/logx"
	"fmt"
	"time"
	"xorm.io/xorm"
)

// OrderListCountByUIDByOrderTypeByTime is 查询订单 by uid by time ,获取规定时间内的订单类型的订单数
func OrderListSumByUIDByOrderTypeByTimeNew(Db *xorm.Engine, uid interface{}, task *model.UserLevelUpgradeTask) (float64, error) {
	state := []string{"1", "2", "3", "5"}
	timeType := "confirm_at"
	if task.OrdState == 1 { //已付款
		timeType = "create_at"
		state = []string{"0", "1", "2", "3", "5"}
	}
	timeType2 := "created_at"
	timeType4 := "create_time"
	if task.OrdState == 3 {
		timeType = "settle_at"
		timeType2 = "settle_at"
		timeType4 = "settle_at"
	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location())
	etime := t
	var total float64 = 0
	sess := Db.Where("uid = ?  and settle_at=0", uid)
	sess1 := Db.Where("uid = ?  and settle_at>0", uid)
	sess2 := Db.Where("uid = ?", uid)
	sess4 := Db.Where("uid = ?", uid)
	if task.WithinDays > 0 {
		sess.And(" ? > ? AND ? < ?", timeType, timeType, stime.Unix(), etime.Unix())
		sess1.And(" ? > ? AND ? < ?", timeType, timeType, stime.Unix(), etime.Unix())
		sess2.And(" ? > ? AND ? < ?", timeType2, timeType2, stime.Unix(), etime.Unix())
		sess4.And(" ? > ? AND ? < ?", timeType4, timeType4, stime.Format("2006-01-02 15:04:05"), etime.Format("2006-01-02 15:04:05"))
	}
	if task.OrdState == 3 {
		sess2.And("settle_at>0")
		sess4.And("settle_at>0")
	}
	if task.OrdState != 3 {
		total, _ = sess.In("state", state).Sum(&model.OrdList{}, "paid_price")
		total3, _ := Db.Where("uid = ?  AND settle_at > ? AND settle_at < ? and confirm_at=0", uid, stime, etime).Sum(&model.OrdList{}, "paid_price")
		total += total3
	}
	total1, _ := sess1.Sum(&model.OrdList{}, "paid_price")
	total2, _ := sess2.Where("state=?", uid, 1).Sum(&model.PrivilegeCardOrd{}, "paid_price")
	total4, _ := sess4.Where("status=?", uid, "已付款").Sum(&model.RechargeOrder{}, "amount")

	fmt.Println(total)

	return total + total1 + total2 + total4, nil
}

func MallOrdWithSumNew(Db *xorm.Engine, uid interface{}, orderType int, task *model.UserLevelUpgradeTask) (float64, error) {
	state := []string{"2", "3"}
	timeType := "confirm_time"
	if task.OrdState == 1 { //已付款
		timeType = "create_time"
		state = []string{"1", "2", "3"}
	}
	if task.OrdState == 3 {
		timeType = "settle_time"
	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location()).Format("2006-01-02 15:04:05")
	etime := t.Format("2006-01-02 15:04:05")
	sess := Db.Where("uid = ?  ", uid)
	if zhios_condition_statistics_utils.AnyToInt64(orderType) > 0 {
		sess.And("order_type=?", orderType)
	}
	if task.WithinDays > 0 {
		sess.And(" ? > ? AND ? < ?", timeType, timeType, stime, etime)
	}
	if task.OrdState == 3 {
		sess.And("settle_time is not null")
	}
	if task.OrdState != 3 {
		sess.In("state", state)
	}

	total, err := sess.Sum(&model.MallOrd{}, "cost_price")
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}
func O2oOrdWithSumNew(Db *xorm.Engine, uid interface{}, task *model.UserLevelUpgradeTask) (float64, error) {
	state := []string{"2", "3"}
	timeType := "confirm_time"
	timeType1 := "create_time"
	if task.OrdState == 1 { //已付款
		timeType = "create_time"
		state = []string{"1", "2", "3"}
	}
	if task.OrdState == 3 {
		timeType = "settle_time"
		timeType1 = "settle_time"

	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location()).Format("2006-01-02 15:04:05")
	etime := t.Format("2006-01-02 15:04:05")
	sess := Db.Where("uid = ?  ", uid)
	if task.WithinDays > 0 {
		sess.And(" ? > ? AND ? < ?", timeType, timeType, stime, etime)
	}
	if task.OrdState == 3 {
		sess.And("settle_time is not null")
	}
	if task.OrdState != 3 {
		sess.In("state", state)
	}
	total, err := sess.Sum(&model.O2oOrd{}, "cost_price")
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	sess1 := Db.Where("uid = ?  ", uid)
	if task.WithinDays > 0 {
		sess1.And(" ? > ? AND ? < ?", timeType1, timeType1, stime, etime)
	}
	if task.OrdState == 3 {
		sess.And("settle_time is not null")
	} else {
		sess.And("state in (?)", "1,4")
	}
	total1, err1 := sess1.Sum(&model.O2oPayToMerchant{}, "actual_pay_amount")
	if err1 != nil {
		return total, zhios_condition_statistics_logx.Error(err)
	}
	total += total1
	return total, nil
}
func B2cOrdWithSumNew(Db *xorm.Engine, uid interface{}, task *model.UserLevelUpgradeTask) (float64, error) {
	state := []string{"2", "3"}
	timeType := "confirm_time"
	if task.OrdState == 1 { //已付款
		timeType = "create_time"
		state = []string{"1", "2", "3"}
	}
	if task.OrdState == 3 {
		timeType = "settle_time"
	}
	t := time.Now()
	stime := time.Date(t.Year(), t.Month(), t.Day()-task.WithinDays, t.Hour(), 0, 0, 0, t.Location()).Format("2006-01-02 15:04:05")
	etime := t.Format("2006-01-02 15:04:05")
	sess := Db.Where("uid = ?  ", uid)
	if task.WithinDays > 0 {
		sess.And(" ? > ? AND ? < ?", timeType, timeType, stime, etime)
	}
	if task.OrdState == 3 {
		sess.And("settle_time is not null")
	}
	if task.OrdState != 3 {
		sess.In("state", state)
	}

	total, err := sess.Sum(&model.B2cOrd{}, "cost_price")
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}
